1. 问题描述
子串应该比较好理解,至于什么是子序列,这里给出一个例子:有两个母串
- cnblogs
- belong
比如序列bo, bg, lg在母串cnblogs与belong中都出现过并且出现顺序与母串保持一致,我们将其称为公共子序列。最长公共子序列(Longest Common Subsequence,LCS),顾名思义,是指在所有的子序列中最长的那一个。子串是要求更严格的一种子序列,要求在母串中连续地出现。在上述例子的中,最长公共子序列为blog(cnblogs,belong),最长公共子串为lo(cnblogs, belong)。
2. 求解算法
对于母串X=<x1,x2,⋯,xm>, Y=<y1,y2,⋯,yn>,求LCS与最长公共子串。
暴力解法
假设 m<n, 对于母串X,我们可以暴力找出2的m次方个子序列,然后依次在母串Y中匹配,算法的时间复杂度会达到指数级O(n∗2的m次)。显然,暴力求解不太适用于此类问题。
动态规划
假设Z=<z1,z2,⋯,zk>是X与Y的LCS, 我们观察到
如果Xm=Yn,则Zk=Xm=Yn,有Zk−1是Xm−1与Yn−1的LCS;
如果Xm≠Yn,则Zk是Xm与Yn−1的LCS,或者是Xm−1与Yn的LCS。
因此,求解LCS的问题则变成递归求解的两个子问题。但是,上述的递归求解的办法中,重复的子问题多,效率低下。改进的办法——用空间换时间,用数组保存中间状态,方便后面的计算。这就是动态规划(DP)的核心思想了。
DP求解LCS
用二维数组c[i][j]记录串x1x2⋯xi与y1y2⋯yj的LCS长度,则可得到状态转移方程
代码实现
1 public static int lcs(String str1, String str2) { 2 int len1 = str1.length(); 3 int len2 = str2.length(); 4 int c[][] = new int[len1+1][len2+1]; 5 for (int i = 0; i <= len1; i++) { 6 for( int j = 0; j <= len2; j++) { 7 if(i == 0 || j == 0) { 8 c[i][j] = 0; 9 } else if (str1.charAt(i-1) == str2.charAt(j-1)) { 10 c[i][j] = c[i-1][j-1] + 1; 11 } else { 12 c[i][j] = max(c[i - 1][j], c[i][j - 1]); 13 } 14 } 15 } 16 return c[len1][len2]; 17 }
DP求解最长公共子串
前面提到了子串是一种特殊的子序列,因此同样可以用DP来解决。定义数组的存储含义对于后面推导转移方程显得尤为重要,糟糕的数组定义会导致异常繁杂的转移方程。考虑到子串的连续性,将二维数组c[i][j]用来记录具有这样特点的子串——结尾同时也为为串x1x2⋯xi与y1y2⋯yj的结尾——的长度。
得到转移方程:
最长公共子串的长度为 max(c[i,j]), i∈{1,⋯,m},j∈{1,⋯,n}。
代码实现
1 public static int lcs(String str1, String str2) { 2 int len1 = str1.length(); 3 int len2 = str2.length(); 4 int result = 0; //记录最长公共子串长度 5 int c[][] = new int[len1+1][len2+1]; 6 for (int i = 0; i <= len1; i++) { 7 for( int j = 0; j <= len2; j++) { 8 if(i == 0 || j == 0) { 9 c[i][j] = 0; 10 } else if (str1.charAt(i-1) == str2.charAt(j-1)) { 11 c[i][j] = c[i-1][j-1] + 1; 12 result = max(c[i][j], result); 13 } else { 14 c[i][j] = 0; 15 } 16 } 17 } 18 return result; 19 }
例题
pat-C4 L2-008 最长对称的回文串
1 #include <bits/stdc++.h> 2 using namespace std; 3 const int N=1e3+10; 4 char s1[N],s2[N]; 5 int dp[N][N]; 6 int main () 7 { 8 gets (s1+1); strcpy(s2+1,s1+1); 9 int len=strlen(s1+1); 10 reverse(s2+1, s2+1+len); 11 int ans=0; 12 for (int i=0;i<=len;i++) 13 for (int j=0;j<=len;j++) { 14 if (i==0||j==0) dp[i][j]=0; 15 else if (s1[i]==s2[j]) { 16 dp[i][j]=dp[i-1][j-1]+1; 17 ans=max (ans,dp[i][j]); 18 } 19 else dp[i][j]=0; 20 } 21 printf ("%d\n",ans); 22 return 0; 23 }